' Generealy the First MDI Child form that a user will see. Handles the initial
' Network and user setups..
' Also handles the visibility of the Login/Logout menu items on the Main form..

Public Class Login_page
    Private Pvt_loop As Integer
    Private Logged As Boolean
    Private WithEvents DefaultInfo As New UserInfo
    Public Event Login_event(ByVal Login As Boolean)

    Private Sub Login_page_Deactivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Deactivate
        Main_F.LoginToolStripMenuItem.Enabled = Not Logged
        Main_F.LogoutToolStripMenuItem.Enabled = Logged
        If Logged Then
            ReDim User(0)
            With User(0)
                .Hidden = False
                .Ignore = False
                .IP = (Net.IPAddress.Parse(ComboBox1.Items(ComboBox1.SelectedIndex).ToString))
                .Name = TextBox3.Text
                .Local = True
            End With
            Subnet = Net.IPAddress.Parse(TextBox1.Text)
            L_Port = CInt(TextBox2.Text)
            RaiseEvent Login_event(Logged)
        End If
    End Sub

    Private Sub Login_page_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    End Sub

    Private Sub Login_page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Main_F.LoginToolStripMenuItem.Enabled = False
        Main_F.LogoutToolStripMenuItem.Enabled = False
        Dim Connections As ArrayList
        Connections = GetLIPAdresses()
        ComboBox1.Items.AddRange(Connections.ToArray)
        If ComboBox1.Items.Count > 0 Then ComboBox1.SelectedIndex = 0
        ' Soon to be loaded and saved to Either reg or ini file (still deciding)
        ' Thanks to Sotoasty - Loaded from Reg...
        DefaultInfo.Load()
        TextBox1.Text = DefaultInfo.SubNetMask
        TextBox2.Text = DefaultInfo.DefaultPort
        TextBox3.Text = DefaultInfo.UserName
        Logged = False
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Logged = False
        Me.Hide()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        L_IP = Net.IPAddress.Parse(ComboBox1.SelectedItem.ToString)
        Logged = True
        DefaultInfo.IPAddress = Me.ComboBox1.Text
        DefaultInfo.SubNetMask = Me.TextBox1.Text
        DefaultInfo.DefaultPort = Me.TextBox2.Text
        DefaultInfo.UserName = Me.TextBox3.Text
        DefaultInfo.Save()
        Me.Hide()
    End Sub

    Private Sub DefaultInfo_Int_Error(ByVal Err_val As UserInfo.Error_type) Handles DefaultInfo.Int_Error
        Dim Tmp_Msg As MsgBoxResult
        Select Case Err_val
            Case UserInfo.Error_type.Load_Err
                MsgBox("Error Loading From Registary, Using Default Values", MsgBoxStyle.Exclamation, "IP Chat")
            Case UserInfo.Error_type.Save_Err
                Tmp_Msg = MsgBox("Error Saving to Registary?", MsgBoxStyle.AbortRetryIgnore, "IP Chat")
                Select Case Tmp_Msg
                    Case MsgBoxResult.Retry
                        DefaultInfo.Save()
                    Case MsgBoxResult.Abort
                        Logged = False
                    Case MsgBoxResult.Ignore
                        'Ignore and continue anyways..
                End Select
        End Select
    End Sub
End Class